myauth/urls.py
from django.contrib.auth.views import LoginView
from django.urls import path

from myauth.views import get_cookie_view, set_cookie_view, set_session_view, get_session_view, MyLogoutView, \
    AboutMeView, RegisterView, FooBarView

app_name = 'myauth'

urlpatterns = [
    path(
        'login/',
        LoginView.as_view(template_name='myauth/login.html', redirect_authenticated_user=True),
        name='login'
    ),
    path('logout/', MyLogoutView.as_view(), name='logout'),
    path('about-me/', AboutMeView.as_view(), name='about-me'),
    path('register/', RegisterView.as_view(), name='register'),
    path('cookie/get/', get_cookie_view, name='cookie_get'),
    path('cookie/set/', set_cookie_view, name='cookie_set'),
    path('session/set/', set_session_view, name='session_set'),
    path('session/get/', get_session_view, name='session_get'),
    path('foo-bar/', FooBarView.as_view, name='foo-bar'),
]

mysite/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('shop/', include('shopapp.urls')),
    path('req/', include('requestdataapp.urls')),
    path('myauth/', include('myauth.urls')),
]

if settings.DEBUG:
    urlpatterns.extend(
        static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    )

if settings.DEBUG:
    urlpatterns.extend(
        static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    )

shopapp/urls.py
from django.urls import path

from shopapp.views import ShopIndexView, GroupsListView, ProductDetailsView, ProductsListView, \
    OrdersListView, OrderDetailView, ProductCreateView, ProductUpdateView, ProductDeleteView, OrderCreateView, \
    OrderUpdateView, OrderDeleteView, ProductsDataExportView

app_name = 'shopapp'

urlpatterns = [
    path('', ShopIndexView.as_view(), name='index'),
    path('groups/', GroupsListView.as_view(), name='groups_list'),
    path('products/', ProductsListView.as_view(), name='products_list'),
    path('products/export/', ProductsDataExportView.as_view(), name='products-export'),
    path('products/create/', ProductCreateView.as_view(), name='product_create'),
    path('products/<int:pk>/', ProductDetailsView.as_view(), name='product_details'),
    path('products/<int:pk>/update/', ProductUpdateView.as_view(), name='product_update'),
    path('products/<int:pk>/archived/', ProductDeleteView.as_view(), name='product_delete'),
    path('orders/', OrdersListView.as_view(), name='orders_list'),
    path('orders/<int:pk>/', OrderDetailView.as_view(), name='order_details'),
    path('orders/<int:pk>/update/', OrderUpdateView.as_view(), name='order_update'),
    path('orders/<int:pk>/delete/', OrderDeleteView.as_view(), name='order_delete'),
    path('orders/create/', OrderCreateView.as_view(), name='orders_create'),
]

shopapp/models.py
from django.contrib.auth.models import User
from django.db import models


def product_preview_directory_path(inastance: 'Product', filename: str) -> str:
    return 'products/product_{pk}/preview/{filename}'.format(pk=inastance.pk, filename=filename)


class Product(models.Model):
    name = models.CharField(max_length=100)
    description = models.TextField(null=False, blank=True)
    price = models.DecimalField(default=0, max_digits=8, decimal_places=2)
    discount = models.SmallIntegerField(default=0)
    created_at = models.DateTimeField(auto_now_add=True)
    archived = models.BooleanField(default=False)
    preview = models.ImageField(null=True, blank=True, upload_to=product_preview_directory_path)

    def __str__(self) -> str:
        return f"Product(pk={self.pk}, name={self.name!r})"

    class Meta:
        ordering = ['name', 'price']
        # db_table = 'tech_products'
        # verbose_name_plural = 'products'


def product_images_directory_path(instance: 'ProductImage', filename: 'str') -> str:
    return 'products/product_{pk}/images/{filename}'.format(pk=instance.product.pk, filename=filename)


class ProductImage(models.Model):
    product = models.ForeignKey(Product, on_delete=models.CASCADE, related_name='images')
    image = models.ImageField(upload_to=product_images_directory_path)
    descriprion = models.CharField(max_length=200, null=False, blank=True)


class Order(models.Model):
    delivery_address = models.TextField(null=True, blank=True)
    promocode = models.CharField(max_length=20, null=False, blank=True)
    created_at = models.DateTimeField(auto_now_add=True)
    user = models.ForeignKey(User, on_delete=models.PROTECT)
    products = models.ManyToManyField(Product, related_name='orders')
    receipt = models.FileField(null=True, upload_to='orders/receipts/')

shopapp/forms.py
from django import forms
from django.contrib.auth.models import Group

from shopapp.models import Order, Product


class OrderForm(forms.ModelForm):
    class Meta:
        model = Order
        fields = 'user', 'products', 'delivery_address', 'promocode'


class GroupForm(forms.ModelForm):
    class Meta:
        model = Group
        fields = ('name',)


class ProductForm(forms.ModelForm):
    class Meta:
        model = Product
        fields = 'name', 'price', 'description', 'discount', 'preview'

    images = forms.ImageField(widget=forms.ClearableFileInput(attrs={'multiple': True}))

shopapp/views.py
from datetime import datetime
from timeit import default_timer

from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin, UserPassesTestMixin
from django.contrib.auth.models import Group
from django.http import HttpRequest, HttpResponse, HttpResponseRedirect, JsonResponse
from django.shortcuts import render, redirect, reverse
from django.urls import reverse_lazy
from django.views import View
from django.views.generic import ListView, DetailView, CreateView, UpdateView, DeleteView

from shopapp.forms import GroupForm, ProductForm
from shopapp.models import Product, Order, ProductImage


class ShopIndexView(View):
    def get(self, request: HttpRequest) -> HttpResponse:
        products = {
            'Laptop': 1999,
            'Desktop': 2999,
            'Smartphone': 999,
        }
        context = {
            'time_running': default_timer(),
            'datetime_now': datetime.now(),
            'products': products,
        }
        return render(request, 'shopapp/shop-index.html', context=context)


class GroupsListView(View):
    def get(self, request: HttpRequest):
        context = {
            'groups': Group.objects.prefetch_related('permissions').all(),
            'form': GroupForm()
        }
        return render(request, 'shopapp/groups-list.html', context=context)

    def post(self, request: HttpRequest):
        form = GroupForm(request.POST)

        if form.is_valid():
            form.save()

        return redirect(request.path)


class ProductDetailsView(DetailView):
    template_name = 'shopapp/products-details.html'
    # model = Product
    queryset = Product.objects.prefetch_related('images')
    context_object_name = 'product'


class ProductsListView(ListView):
    template_name = 'shopapp/products-list.html'
    # model = Product
    context_object_name = 'products'
    queryset = Product.objects.filter(archived=False)


class ProductCreateView(UserPassesTestMixin, CreateView):
    def test_func(self):
        return self.request.user.is_superuser

    model = Product
    fields = 'name', 'price', 'description', 'discount', 'preview'
    success_url = reverse_lazy('shopapp:products_list')


class ProductUpdateView(UpdateView):
    model = Product
    # fields = 'name', 'price', 'description', 'discount', 'preview'
    template_name_suffix = '_update_form'
    form_class = ProductForm

    def get_success_url(self):
        return reverse('shopapp:product_details', kwargs={'pk': self.object.pk})

    def form_valid(self, form):
        response = super().form_valid(form)

        for image in form.files.getlist('images'):
            ProductImage.objects.create(product=self.object, image=image)

        return response


class ProductDeleteView(DeleteView):
    model = Product
    success_url = reverse_lazy('shopapp:products_list')

    def form_valid(self, form):
        success_url = self.get_success_url()
        self.object.archived = True
        self.object.save()
        return HttpResponseRedirect(success_url)


class OrdersListView(LoginRequiredMixin, ListView):
    queryset = Order.objects.select_related('user').prefetch_related('products')


class OrderDetailView(DetailView):
    queryset = Order.objects.select_related('user').prefetch_related('products')


class OrderCreateView(CreateView):
    model = Order
    fields = 'user', 'products', 'delivery_address', 'promocode'
    success_url = reverse_lazy('shopapp:orders_list')


class OrderUpdateView(UpdateView):
    model = Order
    fields = 'user', 'products', 'delivery_address', 'promocode'
    template_name_suffix = '_update_form'

    def get_success_url(self):
        return reverse('shopapp:order_details', kwargs={'pk': self.object.pk})


class OrderDeleteView(PermissionRequiredMixin, DeleteView):
    permission_required = 'shopapp.view_order'
    model = Order
    success_url = reverse_lazy('shopapp:orders_list')


class ProductsDataExportView(View):
    def get(self, request: HttpRequest) -> JsonResponse:
        products = Product.objects.order_by('pk').all()
        products_data = [
            {
                'pk': product.pk,
                'name': product.name,
                'price': product.price,
                'archived': product.archived,
            }
            for product in products
        ]
        return JsonResponse({'products': products_data})

shopapp/templates/shopapp/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-KK94CHFLLe+nY2dmCWGMq91rCGa5gtU4mk92HdvYe+M/SXH301p5ILy+dN9+nJOZ" crossorigin="anonymous">
    <title>
        {% block title %}
            Base Title
        {% endblock %}
    </title>
</head>
<body>
<div class="container">
    <div class="row justify-content-center">
        <div class="col-8">
            {% block body %}
                Base Body
            {% endblock %}
            <br/>
            <hr/>
            <div>
                {% now 'd-M-Y H:i' %}
            </div>
            <div>
                {% now 'l' as current_weakday %}
                Today is {{ current_weakday }}
            </div>
        </div>
    </div>
</div>
</body>
</html>

shopapp/templates/shopapp/groups-list.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Group list
{% endblock %}

{% block body %}
    <h1>Group</h1>
    <div>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Create</button>
        </form>
    </div>
    <div>
        {% if not groups %}
            <h3>No groups yet</h3>
        {% else %}
            {% for group in groups %}
                <li>
                    <div>
                        {{ group }}
                    </div>
                    <div>
                        <ul>
                            {% for permission in group.permissions.all %}
                                <li>
                                    {{ permission.name }}
                                    (<code>{{ permission.codename }}</code>)
                                </li>
                            {% endfor %}

                        </ul>
                    </div>
                </li>
            {% endfor %}
        {% endif %}
    </div>
{% endblock %}

shopapp/templates/shopapp/order_confirm_delete.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Confirm delete {{ object.name }}
{% endblock %}

{% block body %}
    <h1>Are you sure want to deleted {{ object.name }}?</h1>
    <br>
    <div>
        <a href="{% url 'shopapp:order_details' pk=object.pk %}">Back to order</a>
    </div>
    <br>
    <div>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Delete</button>
        </form>
    </div>
{% endblock %}

shopapp/templates/shopapp/order_detail.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Order №{{ object.pk }} details
{% endblock %}

{% block body %}
    <h1>Order №{{ object.pk }}</h1>
    <div>
        <p>Order by: {% firstof object.user.first_name object.user.username %}</p>
        <p>Promocode: {{ object.promocode }}</p>
        <p>Delivery address{{ object.delivery_address }}</p>
        <div>
            Product in order:
            <ul>
                {% for product in object.products.all %}
                    <li>{{ product.name }} for ${{ product.price }}</li>
                {% endfor %}
            </ul>
        </div>
    </div>
    <div>
        <a href="{% url 'shopapp:order_update' pk=order.pk %}">Update order</a>
        <br>
        <a href="{% url 'shopapp:order_delete' pk=order.pk %}">Delete order</a>
        <br>
        <a href="{% url 'shopapp:orders_list' %}">Back to orders list</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/order_form.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Create order
{% endblock %}

{% block body %}
    <h1>Create a new order</h1>
    <div>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Create</button>
        </form>
    </div>
    <br>
    <div>
        <a href="{% url 'shopapp:orders_list' %}">Product list</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/order_list.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Orders list
{% endblock %}

{% block body %}
    <h1>Orders:</h1>
    <div>
        {% if not object_list %}
            No order yet
        {% else %}
            <div>
                {% for order in object_list %}
                    <div>
                        <p><a href="{% url 'shopapp:order_details' pk=order.pk %}">Details {{ order.pk }}</a></p>
                        <p>Order by: {% firstof order.user.first_name order.user.username %}</p>
                        <p>Promocode: {{ order.promocode }}</p>
                        <p>Delivery address{{ order.delivery_address }}</p>
                        <div>
                            Product in order:
                            <ul>
                                {% for product in order.products.all %}
                                    <li>{{ product.name }} for ${{ product.price }}</li>
                                {% endfor %}
                            </ul>
                        </div>
                    </div>
                    <hr>
                {% endfor %}
            </div>
        {% endif %}
    </div>
    <div>
        <a href="{% url 'shopapp:orders_create' %}">Create a new order</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/order_update_form.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Update order
{% endblock %}

{% block body %}
    <h1>Update order №{{ object.pk }}</h1>
    <div>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Update</button>
        </form>
    </div>
    <br>
    <div>
        <a href="{% url 'shopapp:order_details' pk=object.pk %}">Back to order №{{ object.pk }}</a>
        <br>
        <a href="{% url 'shopapp:orders_list' %}">Back to order list</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/product_confirm_delete.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Confirm archived {{ object.name }}
{% endblock %}

{% block body %}
    <h1>Are you sure want to archived {{ object.name }}?</h1>
    <br>
    <div>
        <a href="{% url 'shopapp:product_details' pk=object.pk %}">Back to product</a>
    </div>
    <br>
    <div>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Archived</button>
        </form>
    </div>
{% endblock %}

shopapp/templates/shopapp/product_form.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Create product
{% endblock %}

{% block body %}
    <h1>Create a new product</h1>
    <div>
        <form method="post" enctype="multipart/form-data">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Create</button>
        </form>
    </div>
    <br>
    <div>
        <a href="{% url 'shopapp:products_list' %}">Product list</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/product_update_form.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Update product
{% endblock %}

{% block body %}
    <h1>Update product {{ product.pk }}</h1>
    <div>
        <form method="post" enctype="multipart/form-data">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Update</button>
        </form>
    </div>
    <br>
    <div>
        <a href="{% url 'shopapp:product_details' pk=object.pk %}">Back to {{ object.name }}</a>
        <br>
        <a href="{% url 'shopapp:products_list' %}">Product list</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/products-details.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Product №{{ product.pk }}
{% endblock %}

{% block body %}
    <h1>Product <strong>{{ product.name }}</strong></h1>
    <div>
        <div>Description: <em>{{ product.description }}</em></div>
        <div>Price: {{ product.price }}</div>
        <div>Discount: {{ product.discount }}</div>
        <div>Archived: {{ product.archived }}</div>
        {% if product.preview %}
            <img src="{{ product.preview.url }}" alt="{{ product.preview.name }}">
        {% endif %}
        <h3>Images:</h3>
        <div>
            {% for img in product.images.all %}
                <div>
                    <img src="{{ img.image.url }}" alt="{{ img.image.name }}">
                    <div>{{ img.description }}</div>
                </div>
            {% empty %}
                <div>No images uploaded yet</div>
            {% endfor %}
        </div>
    </div>
    <br>
    <div align="right">
        <a href="{% url 'shopapp:product_update' pk=product.pk %}">Update product</a>
        <br>
        <a href="{% url 'shopapp:product_delete' pk=product.pk %}">Archived product</a>
        <br>
        <a href="{% url 'shopapp:products_list' %}">Back to Products list</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/products-list.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Products list
{% endblock %}

{% block body %}
    <h1>Products:</h1>
    {% if products %}
        <div>
            {% for product in products %}
                <div>
                    <p>Name: <a href="{% url 'shopapp:product_details' pk=product.pk %}">{{ product.name }}</a></p>
                    <p>Price ${{ product.price }}</p>
                    {% if product.discount > 0 %}
                        <p>Discount: {{ product.discount }}%</p>
                    {% else %}
                        <p>Discount: no discount</p>
                    {% endif %}
                    {% if product.preview %}
                        <img src="{{ product.preview.url }}" alt="{{ product.preview.name }}">
                    {% endif %}
                </div>
            {% endfor %}
        </div>
    {% else %}
        <h3>No products yet</h3>
    {% endif %}
    <div>
        <a href="{% url 'shopapp:product_create' %}">Create a new product</a>
    </div>
{% endblock %}

shopapp/templates/shopapp/shop-index.html
{% extends 'shopapp/base.html' %}

{% block title %}
    Shop Index
{% endblock %}

{% block body %}
    <h1>Hello Shop Index</h1>
    <div>
        <ul>
            {% for k, v in products.items %}
                <li>{{ k }} ({{ k|length }}) for ${{ v }}</li>
                {% if k|length_is:'7' %}
                    <span>Lucky product!</span>
                {% endif %}
            {% empty %}
                No products
            {% endfor %}
        </ul>
    </div>
    <div>
        Time running: {{ time_running }}
    </div>
    <div>
        {% lorem 3 p random %}
    </div>
{% endblock %}